#include <dcerpc.h>
#include <gen_ndr/samr.h>
#ifndef _HEADER_RPC_samr
#define _HEADER_RPC_samr

extern const struct ndr_interface_table ndr_table_samr;

#ifdef DCERPC_IFACE_SAMR_COMPAT
#define DCERPC_CALL_SAMR_CONNECT_COMPAT 1
#define DCERPC_CALL_SAMR_CLOSE_COMPAT 1
#define DCERPC_CALL_SAMR_SETSECURITY_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYSECURITY_COMPAT 1
#define DCERPC_CALL_SAMR_SHUTDOWN_COMPAT 1
#define DCERPC_CALL_SAMR_LOOKUPDOMAIN_COMPAT 1
#define DCERPC_CALL_SAMR_ENUMDOMAINS_COMPAT 1
#define DCERPC_CALL_SAMR_OPENDOMAIN_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYDOMAININFO_COMPAT 1
#define DCERPC_CALL_SAMR_SETDOMAININFO_COMPAT 1
#define DCERPC_CALL_SAMR_CREATEDOMAINGROUP_COMPAT 1
#define DCERPC_CALL_SAMR_ENUMDOMAINGROUPS_COMPAT 1
#define DCERPC_CALL_SAMR_CREATEUSER_COMPAT 1
#define DCERPC_CALL_SAMR_ENUMDOMAINUSERS_COMPAT 1
#define DCERPC_CALL_SAMR_CREATEDOMALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_ENUMDOMAINALIASES_COMPAT 1
#define DCERPC_CALL_SAMR_GETALIASMEMBERSHIP_COMPAT 1
#define DCERPC_CALL_SAMR_LOOKUPNAMES_COMPAT 1
#define DCERPC_CALL_SAMR_LOOKUPRIDS_COMPAT 1
#define DCERPC_CALL_SAMR_OPENGROUP_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYGROUPINFO_COMPAT 1
#define DCERPC_CALL_SAMR_SETGROUPINFO_COMPAT 1
#define DCERPC_CALL_SAMR_ADDGROUPMEMBER_COMPAT 1
#define DCERPC_CALL_SAMR_DELETEDOMAINGROUP_COMPAT 1
#define DCERPC_CALL_SAMR_DELETEGROUPMEMBER_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYGROUPMEMBER_COMPAT 1
#define DCERPC_CALL_SAMR_SETMEMBERATTRIBUTESOFGROUP_COMPAT 1
#define DCERPC_CALL_SAMR_OPENALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYALIASINFO_COMPAT 1
#define DCERPC_CALL_SAMR_SETALIASINFO_COMPAT 1
#define DCERPC_CALL_SAMR_DELETEDOMALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_ADDALIASMEMBER_COMPAT 1
#define DCERPC_CALL_SAMR_DELETEALIASMEMBER_COMPAT 1
#define DCERPC_CALL_SAMR_GETMEMBERSINALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_OPENUSER_COMPAT 1
#define DCERPC_CALL_SAMR_DELETEUSER_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYUSERINFO_COMPAT 1
#define DCERPC_CALL_SAMR_SETUSERINFO_COMPAT 1
#define DCERPC_CALL_SAMR_CHANGEPASSWORDUSER_COMPAT 1
#define DCERPC_CALL_SAMR_GETGROUPSFORUSER_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYDISPLAYINFO_COMPAT 1
#define DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX_COMPAT 1
#define DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSDOMAIN_COMPAT 1
#define DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSUSER_COMPAT 1
#define DCERPC_CALL_SAMR_GETUSERPWINFO_COMPAT 1
#define DCERPC_CALL_SAMR_REMOVEMEMBERFROMFOREIGNDOMAIN_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYDOMAININFO2_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYUSERINFO2_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYDISPLAYINFO2_COMPAT 1
#define DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX2_COMPAT 1
#define DCERPC_CALL_SAMR_CREATEUSER2_COMPAT 1
#define DCERPC_CALL_SAMR_QUERYDISPLAYINFO3_COMPAT 1
#define DCERPC_CALL_SAMR_ADDMULTIPLEMEMBERSTOALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_REMOVEMULTIPLEMEMBERSFROMALIAS_COMPAT 1
#define DCERPC_CALL_SAMR_OEMCHANGEPASSWORDUSER2_COMPAT 1
#define DCERPC_CALL_SAMR_CHANGEPASSWORDUSER2_COMPAT 1
#define DCERPC_CALL_SAMR_GETDOMPWINFO_COMPAT 1
#define DCERPC_CALL_SAMR_CONNECT2_COMPAT 1
#define DCERPC_CALL_SAMR_SETUSERINFO2_COMPAT 1
#define DCERPC_CALL_SAMR_SETBOOTKEYINFORMATION_COMPAT 1
#define DCERPC_CALL_SAMR_GETBOOTKEYINFORMATION_COMPAT 1
#define DCERPC_CALL_SAMR_CONNECT3_COMPAT 1
#define DCERPC_CALL_SAMR_CONNECT4_COMPAT 1
#define DCERPC_CALL_SAMR_CHANGEPASSWORDUSER3_COMPAT 1
#define DCERPC_CALL_SAMR_CONNECT5_COMPAT 1
#define DCERPC_CALL_SAMR_RIDTOSID_COMPAT 1
#define DCERPC_CALL_SAMR_SETDSRMPASSWORD_COMPAT 1
#define DCERPC_CALL_SAMR_VALIDATEPASSWORD_COMPAT 1
#endif /* DCERPC_IFACE_SAMR_COMPAT */

struct tevent_req *dcerpc_samr_Connect_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Connect *r);
NTSTATUS dcerpc_samr_Connect_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Connect_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Connect *r);
#ifdef DCERPC_CALL_SAMR_CONNECT_COMPAT
#define dcerpc_samr_Connect(p, m, r) dcerpc_samr_Connect_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CONNECT_COMPAT */
NTSTATUS dcerpc_samr_Connect_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Connect *r);
struct tevent_req *dcerpc_samr_Connect_send(TALLOC_CTX *mem_ctx,
					    struct tevent_context *ev,
					    struct dcerpc_binding_handle *h,
					    uint16_t *_system_name /* [in] [unique] */,
					    uint32_t _access_mask /* [in]  */,
					    struct policy_handle *_connect_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_Connect_recv(struct tevent_req *req,
				  TALLOC_CTX *mem_ctx,
				  NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CONNECT_COMPAT
NTSTATUS dcerpc_samr_Connect(struct dcerpc_binding_handle *h,
			     TALLOC_CTX *mem_ctx,
			     uint16_t *_system_name /* [in] [unique] */,
			     uint32_t _access_mask /* [in]  */,
			     struct policy_handle *_connect_handle /* [out] [ref] */,
			     NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CONNECT_COMPAT */

struct tevent_req *dcerpc_samr_Close_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Close *r);
NTSTATUS dcerpc_samr_Close_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Close_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Close *r);
#ifdef DCERPC_CALL_SAMR_CLOSE_COMPAT
#define dcerpc_samr_Close(p, m, r) dcerpc_samr_Close_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CLOSE_COMPAT */
NTSTATUS dcerpc_samr_Close_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Close *r);
struct tevent_req *dcerpc_samr_Close_send(TALLOC_CTX *mem_ctx,
					  struct tevent_context *ev,
					  struct dcerpc_binding_handle *h,
					  struct policy_handle *_handle /* [in,out] [ref] */);
NTSTATUS dcerpc_samr_Close_recv(struct tevent_req *req,
				TALLOC_CTX *mem_ctx,
				NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CLOSE_COMPAT
NTSTATUS dcerpc_samr_Close(struct dcerpc_binding_handle *h,
			   TALLOC_CTX *mem_ctx,
			   struct policy_handle *_handle /* [in,out] [ref] */,
			   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CLOSE_COMPAT */

struct tevent_req *dcerpc_samr_SetSecurity_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetSecurity *r);
NTSTATUS dcerpc_samr_SetSecurity_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetSecurity_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetSecurity *r);
#ifdef DCERPC_CALL_SAMR_SETSECURITY_COMPAT
#define dcerpc_samr_SetSecurity(p, m, r) dcerpc_samr_SetSecurity_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETSECURITY_COMPAT */
NTSTATUS dcerpc_samr_SetSecurity_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetSecurity *r);
struct tevent_req *dcerpc_samr_SetSecurity_send(TALLOC_CTX *mem_ctx,
						struct tevent_context *ev,
						struct dcerpc_binding_handle *h,
						struct policy_handle *_handle /* [in] [ref] */,
						uint32_t _sec_info /* [in]  */,
						struct sec_desc_buf *_sdbuf /* [in] [ref] */);
NTSTATUS dcerpc_samr_SetSecurity_recv(struct tevent_req *req,
				      TALLOC_CTX *mem_ctx,
				      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETSECURITY_COMPAT
NTSTATUS dcerpc_samr_SetSecurity(struct dcerpc_binding_handle *h,
				 TALLOC_CTX *mem_ctx,
				 struct policy_handle *_handle /* [in] [ref] */,
				 uint32_t _sec_info /* [in]  */,
				 struct sec_desc_buf *_sdbuf /* [in] [ref] */,
				 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETSECURITY_COMPAT */

struct tevent_req *dcerpc_samr_QuerySecurity_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QuerySecurity *r);
NTSTATUS dcerpc_samr_QuerySecurity_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QuerySecurity_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QuerySecurity *r);
#ifdef DCERPC_CALL_SAMR_QUERYSECURITY_COMPAT
#define dcerpc_samr_QuerySecurity(p, m, r) dcerpc_samr_QuerySecurity_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYSECURITY_COMPAT */
NTSTATUS dcerpc_samr_QuerySecurity_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QuerySecurity *r);
struct tevent_req *dcerpc_samr_QuerySecurity_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct dcerpc_binding_handle *h,
						  struct policy_handle *_handle /* [in] [ref] */,
						  uint32_t _sec_info /* [in]  */,
						  struct sec_desc_buf **_sdbuf /* [out] [ref] */);
NTSTATUS dcerpc_samr_QuerySecurity_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYSECURITY_COMPAT
NTSTATUS dcerpc_samr_QuerySecurity(struct dcerpc_binding_handle *h,
				   TALLOC_CTX *mem_ctx,
				   struct policy_handle *_handle /* [in] [ref] */,
				   uint32_t _sec_info /* [in]  */,
				   struct sec_desc_buf **_sdbuf /* [out] [ref] */,
				   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYSECURITY_COMPAT */

struct tevent_req *dcerpc_samr_Shutdown_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Shutdown *r);
NTSTATUS dcerpc_samr_Shutdown_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Shutdown_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Shutdown *r);
#ifdef DCERPC_CALL_SAMR_SHUTDOWN_COMPAT
#define dcerpc_samr_Shutdown(p, m, r) dcerpc_samr_Shutdown_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SHUTDOWN_COMPAT */
NTSTATUS dcerpc_samr_Shutdown_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Shutdown *r);
struct tevent_req *dcerpc_samr_Shutdown_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     struct policy_handle *_connect_handle /* [in] [ref] */);
NTSTATUS dcerpc_samr_Shutdown_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SHUTDOWN_COMPAT
NTSTATUS dcerpc_samr_Shutdown(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      struct policy_handle *_connect_handle /* [in] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SHUTDOWN_COMPAT */

struct tevent_req *dcerpc_samr_LookupDomain_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_LookupDomain *r);
NTSTATUS dcerpc_samr_LookupDomain_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_LookupDomain_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_LookupDomain *r);
#ifdef DCERPC_CALL_SAMR_LOOKUPDOMAIN_COMPAT
#define dcerpc_samr_LookupDomain(p, m, r) dcerpc_samr_LookupDomain_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_LOOKUPDOMAIN_COMPAT */
NTSTATUS dcerpc_samr_LookupDomain_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_LookupDomain *r);
struct tevent_req *dcerpc_samr_LookupDomain_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct dcerpc_binding_handle *h,
						 struct policy_handle *_connect_handle /* [in] [ref] */,
						 struct lsa_String *_domain_name /* [in] [ref] */,
						 struct dom_sid2 **_sid /* [out] [ref] */);
NTSTATUS dcerpc_samr_LookupDomain_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_LOOKUPDOMAIN_COMPAT
NTSTATUS dcerpc_samr_LookupDomain(struct dcerpc_binding_handle *h,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *_connect_handle /* [in] [ref] */,
				  struct lsa_String *_domain_name /* [in] [ref] */,
				  struct dom_sid2 **_sid /* [out] [ref] */,
				  NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_LOOKUPDOMAIN_COMPAT */

struct tevent_req *dcerpc_samr_EnumDomains_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_EnumDomains *r);
NTSTATUS dcerpc_samr_EnumDomains_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_EnumDomains_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_EnumDomains *r);
#ifdef DCERPC_CALL_SAMR_ENUMDOMAINS_COMPAT
#define dcerpc_samr_EnumDomains(p, m, r) dcerpc_samr_EnumDomains_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINS_COMPAT */
NTSTATUS dcerpc_samr_EnumDomains_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_EnumDomains *r);
struct tevent_req *dcerpc_samr_EnumDomains_send(TALLOC_CTX *mem_ctx,
						struct tevent_context *ev,
						struct dcerpc_binding_handle *h,
						struct policy_handle *_connect_handle /* [in] [ref] */,
						uint32_t *_resume_handle /* [in,out] [ref] */,
						struct samr_SamArray **_sam /* [out] [ref] */,
						uint32_t _buf_size /* [in]  */,
						uint32_t *_num_entries /* [out] [ref] */);
NTSTATUS dcerpc_samr_EnumDomains_recv(struct tevent_req *req,
				      TALLOC_CTX *mem_ctx,
				      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ENUMDOMAINS_COMPAT
NTSTATUS dcerpc_samr_EnumDomains(struct dcerpc_binding_handle *h,
				 TALLOC_CTX *mem_ctx,
				 struct policy_handle *_connect_handle /* [in] [ref] */,
				 uint32_t *_resume_handle /* [in,out] [ref] */,
				 struct samr_SamArray **_sam /* [out] [ref] */,
				 uint32_t _buf_size /* [in]  */,
				 uint32_t *_num_entries /* [out] [ref] */,
				 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINS_COMPAT */

struct tevent_req *dcerpc_samr_OpenDomain_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_OpenDomain *r);
NTSTATUS dcerpc_samr_OpenDomain_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_OpenDomain_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_OpenDomain *r);
#ifdef DCERPC_CALL_SAMR_OPENDOMAIN_COMPAT
#define dcerpc_samr_OpenDomain(p, m, r) dcerpc_samr_OpenDomain_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_OPENDOMAIN_COMPAT */
NTSTATUS dcerpc_samr_OpenDomain_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_OpenDomain *r);
struct tevent_req *dcerpc_samr_OpenDomain_send(TALLOC_CTX *mem_ctx,
					       struct tevent_context *ev,
					       struct dcerpc_binding_handle *h,
					       struct policy_handle *_connect_handle /* [in] [ref] */,
					       uint32_t _access_mask /* [in]  */,
					       struct dom_sid2 *_sid /* [in] [ref] */,
					       struct policy_handle *_domain_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_OpenDomain_recv(struct tevent_req *req,
				     TALLOC_CTX *mem_ctx,
				     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_OPENDOMAIN_COMPAT
NTSTATUS dcerpc_samr_OpenDomain(struct dcerpc_binding_handle *h,
				TALLOC_CTX *mem_ctx,
				struct policy_handle *_connect_handle /* [in] [ref] */,
				uint32_t _access_mask /* [in]  */,
				struct dom_sid2 *_sid /* [in] [ref] */,
				struct policy_handle *_domain_handle /* [out] [ref] */,
				NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_OPENDOMAIN_COMPAT */

struct tevent_req *dcerpc_samr_QueryDomainInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryDomainInfo *r);
NTSTATUS dcerpc_samr_QueryDomainInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryDomainInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryDomainInfo *r);
#ifdef DCERPC_CALL_SAMR_QUERYDOMAININFO_COMPAT
#define dcerpc_samr_QueryDomainInfo(p, m, r) dcerpc_samr_QueryDomainInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYDOMAININFO_COMPAT */
NTSTATUS dcerpc_samr_QueryDomainInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryDomainInfo *r);
struct tevent_req *dcerpc_samr_QueryDomainInfo_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct dcerpc_binding_handle *h,
						    struct policy_handle *_domain_handle /* [in] [ref] */,
						    enum samr_DomainInfoClass _level /* [in]  */,
						    union samr_DomainInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryDomainInfo_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYDOMAININFO_COMPAT
NTSTATUS dcerpc_samr_QueryDomainInfo(struct dcerpc_binding_handle *h,
				     TALLOC_CTX *mem_ctx,
				     struct policy_handle *_domain_handle /* [in] [ref] */,
				     enum samr_DomainInfoClass _level /* [in]  */,
				     union samr_DomainInfo **_info /* [out] [ref,switch_is(level)] */,
				     NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYDOMAININFO_COMPAT */

struct tevent_req *dcerpc_samr_SetDomainInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetDomainInfo *r);
NTSTATUS dcerpc_samr_SetDomainInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetDomainInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetDomainInfo *r);
#ifdef DCERPC_CALL_SAMR_SETDOMAININFO_COMPAT
#define dcerpc_samr_SetDomainInfo(p, m, r) dcerpc_samr_SetDomainInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETDOMAININFO_COMPAT */
NTSTATUS dcerpc_samr_SetDomainInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetDomainInfo *r);
struct tevent_req *dcerpc_samr_SetDomainInfo_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct dcerpc_binding_handle *h,
						  struct policy_handle *_domain_handle /* [in] [ref] */,
						  enum samr_DomainInfoClass _level /* [in]  */,
						  union samr_DomainInfo *_info /* [in] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_SetDomainInfo_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETDOMAININFO_COMPAT
NTSTATUS dcerpc_samr_SetDomainInfo(struct dcerpc_binding_handle *h,
				   TALLOC_CTX *mem_ctx,
				   struct policy_handle *_domain_handle /* [in] [ref] */,
				   enum samr_DomainInfoClass _level /* [in]  */,
				   union samr_DomainInfo *_info /* [in] [ref,switch_is(level)] */,
				   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETDOMAININFO_COMPAT */

struct tevent_req *dcerpc_samr_CreateDomainGroup_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_CreateDomainGroup *r);
NTSTATUS dcerpc_samr_CreateDomainGroup_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_CreateDomainGroup_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_CreateDomainGroup *r);
#ifdef DCERPC_CALL_SAMR_CREATEDOMAINGROUP_COMPAT
#define dcerpc_samr_CreateDomainGroup(p, m, r) dcerpc_samr_CreateDomainGroup_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CREATEDOMAINGROUP_COMPAT */
NTSTATUS dcerpc_samr_CreateDomainGroup_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_CreateDomainGroup *r);
struct tevent_req *dcerpc_samr_CreateDomainGroup_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_domain_handle /* [in] [ref] */,
						      struct lsa_String *_name /* [in] [ref] */,
						      uint32_t _access_mask /* [in]  */,
						      struct policy_handle *_group_handle /* [out] [ref] */,
						      uint32_t *_rid /* [out] [ref] */);
NTSTATUS dcerpc_samr_CreateDomainGroup_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CREATEDOMAINGROUP_COMPAT
NTSTATUS dcerpc_samr_CreateDomainGroup(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_domain_handle /* [in] [ref] */,
				       struct lsa_String *_name /* [in] [ref] */,
				       uint32_t _access_mask /* [in]  */,
				       struct policy_handle *_group_handle /* [out] [ref] */,
				       uint32_t *_rid /* [out] [ref] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CREATEDOMAINGROUP_COMPAT */

struct tevent_req *dcerpc_samr_EnumDomainGroups_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_EnumDomainGroups *r);
NTSTATUS dcerpc_samr_EnumDomainGroups_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_EnumDomainGroups_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_EnumDomainGroups *r);
#ifdef DCERPC_CALL_SAMR_ENUMDOMAINGROUPS_COMPAT
#define dcerpc_samr_EnumDomainGroups(p, m, r) dcerpc_samr_EnumDomainGroups_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINGROUPS_COMPAT */
NTSTATUS dcerpc_samr_EnumDomainGroups_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_EnumDomainGroups *r);
struct tevent_req *dcerpc_samr_EnumDomainGroups_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     struct policy_handle *_domain_handle /* [in] [ref] */,
						     uint32_t *_resume_handle /* [in,out] [ref] */,
						     struct samr_SamArray **_sam /* [out] [ref] */,
						     uint32_t _max_size /* [in]  */,
						     uint32_t *_num_entries /* [out] [ref] */);
NTSTATUS dcerpc_samr_EnumDomainGroups_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ENUMDOMAINGROUPS_COMPAT
NTSTATUS dcerpc_samr_EnumDomainGroups(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      struct policy_handle *_domain_handle /* [in] [ref] */,
				      uint32_t *_resume_handle /* [in,out] [ref] */,
				      struct samr_SamArray **_sam /* [out] [ref] */,
				      uint32_t _max_size /* [in]  */,
				      uint32_t *_num_entries /* [out] [ref] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINGROUPS_COMPAT */

struct tevent_req *dcerpc_samr_CreateUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_CreateUser *r);
NTSTATUS dcerpc_samr_CreateUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_CreateUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_CreateUser *r);
#ifdef DCERPC_CALL_SAMR_CREATEUSER_COMPAT
#define dcerpc_samr_CreateUser(p, m, r) dcerpc_samr_CreateUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CREATEUSER_COMPAT */
NTSTATUS dcerpc_samr_CreateUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_CreateUser *r);
struct tevent_req *dcerpc_samr_CreateUser_send(TALLOC_CTX *mem_ctx,
					       struct tevent_context *ev,
					       struct dcerpc_binding_handle *h,
					       struct policy_handle *_domain_handle /* [in] [ref] */,
					       struct lsa_String *_account_name /* [in] [ref] */,
					       uint32_t _access_mask /* [in]  */,
					       struct policy_handle *_user_handle /* [out] [ref] */,
					       uint32_t *_rid /* [out] [ref] */);
NTSTATUS dcerpc_samr_CreateUser_recv(struct tevent_req *req,
				     TALLOC_CTX *mem_ctx,
				     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CREATEUSER_COMPAT
NTSTATUS dcerpc_samr_CreateUser(struct dcerpc_binding_handle *h,
				TALLOC_CTX *mem_ctx,
				struct policy_handle *_domain_handle /* [in] [ref] */,
				struct lsa_String *_account_name /* [in] [ref] */,
				uint32_t _access_mask /* [in]  */,
				struct policy_handle *_user_handle /* [out] [ref] */,
				uint32_t *_rid /* [out] [ref] */,
				NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CREATEUSER_COMPAT */

struct tevent_req *dcerpc_samr_EnumDomainUsers_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_EnumDomainUsers *r);
NTSTATUS dcerpc_samr_EnumDomainUsers_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_EnumDomainUsers_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_EnumDomainUsers *r);
#ifdef DCERPC_CALL_SAMR_ENUMDOMAINUSERS_COMPAT
#define dcerpc_samr_EnumDomainUsers(p, m, r) dcerpc_samr_EnumDomainUsers_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINUSERS_COMPAT */
NTSTATUS dcerpc_samr_EnumDomainUsers_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_EnumDomainUsers *r);
struct tevent_req *dcerpc_samr_EnumDomainUsers_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct dcerpc_binding_handle *h,
						    struct policy_handle *_domain_handle /* [in] [ref] */,
						    uint32_t *_resume_handle /* [in,out] [ref] */,
						    uint32_t _acct_flags /* [in]  */,
						    struct samr_SamArray **_sam /* [out] [ref] */,
						    uint32_t _max_size /* [in]  */,
						    uint32_t *_num_entries /* [out] [ref] */);
NTSTATUS dcerpc_samr_EnumDomainUsers_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ENUMDOMAINUSERS_COMPAT
NTSTATUS dcerpc_samr_EnumDomainUsers(struct dcerpc_binding_handle *h,
				     TALLOC_CTX *mem_ctx,
				     struct policy_handle *_domain_handle /* [in] [ref] */,
				     uint32_t *_resume_handle /* [in,out] [ref] */,
				     uint32_t _acct_flags /* [in]  */,
				     struct samr_SamArray **_sam /* [out] [ref] */,
				     uint32_t _max_size /* [in]  */,
				     uint32_t *_num_entries /* [out] [ref] */,
				     NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINUSERS_COMPAT */

struct tevent_req *dcerpc_samr_CreateDomAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_CreateDomAlias *r);
NTSTATUS dcerpc_samr_CreateDomAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_CreateDomAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_CreateDomAlias *r);
#ifdef DCERPC_CALL_SAMR_CREATEDOMALIAS_COMPAT
#define dcerpc_samr_CreateDomAlias(p, m, r) dcerpc_samr_CreateDomAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CREATEDOMALIAS_COMPAT */
NTSTATUS dcerpc_samr_CreateDomAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_CreateDomAlias *r);
struct tevent_req *dcerpc_samr_CreateDomAlias_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_domain_handle /* [in] [ref] */,
						   struct lsa_String *_alias_name /* [in] [ref] */,
						   uint32_t _access_mask /* [in]  */,
						   struct policy_handle *_alias_handle /* [out] [ref] */,
						   uint32_t *_rid /* [out] [ref] */);
NTSTATUS dcerpc_samr_CreateDomAlias_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CREATEDOMALIAS_COMPAT
NTSTATUS dcerpc_samr_CreateDomAlias(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_domain_handle /* [in] [ref] */,
				    struct lsa_String *_alias_name /* [in] [ref] */,
				    uint32_t _access_mask /* [in]  */,
				    struct policy_handle *_alias_handle /* [out] [ref] */,
				    uint32_t *_rid /* [out] [ref] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CREATEDOMALIAS_COMPAT */

struct tevent_req *dcerpc_samr_EnumDomainAliases_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_EnumDomainAliases *r);
NTSTATUS dcerpc_samr_EnumDomainAliases_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_EnumDomainAliases_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_EnumDomainAliases *r);
#ifdef DCERPC_CALL_SAMR_ENUMDOMAINALIASES_COMPAT
#define dcerpc_samr_EnumDomainAliases(p, m, r) dcerpc_samr_EnumDomainAliases_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINALIASES_COMPAT */
NTSTATUS dcerpc_samr_EnumDomainAliases_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_EnumDomainAliases *r);
struct tevent_req *dcerpc_samr_EnumDomainAliases_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_domain_handle /* [in] [ref] */,
						      uint32_t *_resume_handle /* [in,out] [ref] */,
						      struct samr_SamArray **_sam /* [out] [ref] */,
						      uint32_t _max_size /* [in]  */,
						      uint32_t *_num_entries /* [out] [ref] */);
NTSTATUS dcerpc_samr_EnumDomainAliases_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ENUMDOMAINALIASES_COMPAT
NTSTATUS dcerpc_samr_EnumDomainAliases(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_domain_handle /* [in] [ref] */,
				       uint32_t *_resume_handle /* [in,out] [ref] */,
				       struct samr_SamArray **_sam /* [out] [ref] */,
				       uint32_t _max_size /* [in]  */,
				       uint32_t *_num_entries /* [out] [ref] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ENUMDOMAINALIASES_COMPAT */

struct tevent_req *dcerpc_samr_GetAliasMembership_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetAliasMembership *r);
NTSTATUS dcerpc_samr_GetAliasMembership_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetAliasMembership_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetAliasMembership *r);
#ifdef DCERPC_CALL_SAMR_GETALIASMEMBERSHIP_COMPAT
#define dcerpc_samr_GetAliasMembership(p, m, r) dcerpc_samr_GetAliasMembership_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETALIASMEMBERSHIP_COMPAT */
NTSTATUS dcerpc_samr_GetAliasMembership_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetAliasMembership *r);
struct tevent_req *dcerpc_samr_GetAliasMembership_send(TALLOC_CTX *mem_ctx,
						       struct tevent_context *ev,
						       struct dcerpc_binding_handle *h,
						       struct policy_handle *_domain_handle /* [in] [ref] */,
						       struct lsa_SidArray *_sids /* [in] [ref] */,
						       struct samr_Ids *_rids /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetAliasMembership_recv(struct tevent_req *req,
					     TALLOC_CTX *mem_ctx,
					     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETALIASMEMBERSHIP_COMPAT
NTSTATUS dcerpc_samr_GetAliasMembership(struct dcerpc_binding_handle *h,
					TALLOC_CTX *mem_ctx,
					struct policy_handle *_domain_handle /* [in] [ref] */,
					struct lsa_SidArray *_sids /* [in] [ref] */,
					struct samr_Ids *_rids /* [out] [ref] */,
					NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETALIASMEMBERSHIP_COMPAT */

struct tevent_req *dcerpc_samr_LookupNames_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_LookupNames *r);
NTSTATUS dcerpc_samr_LookupNames_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_LookupNames_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_LookupNames *r);
#ifdef DCERPC_CALL_SAMR_LOOKUPNAMES_COMPAT
#define dcerpc_samr_LookupNames(p, m, r) dcerpc_samr_LookupNames_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_LOOKUPNAMES_COMPAT */
NTSTATUS dcerpc_samr_LookupNames_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_LookupNames *r);
struct tevent_req *dcerpc_samr_LookupNames_send(TALLOC_CTX *mem_ctx,
						struct tevent_context *ev,
						struct dcerpc_binding_handle *h,
						struct policy_handle *_domain_handle /* [in] [ref] */,
						uint32_t _num_names /* [in] [range(0,1000)] */,
						struct lsa_String *_names /* [in] [length_is(num_names),size_is(1000)] */,
						struct samr_Ids *_rids /* [out] [ref] */,
						struct samr_Ids *_types /* [out] [ref] */);
NTSTATUS dcerpc_samr_LookupNames_recv(struct tevent_req *req,
				      TALLOC_CTX *mem_ctx,
				      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_LOOKUPNAMES_COMPAT
NTSTATUS dcerpc_samr_LookupNames(struct dcerpc_binding_handle *h,
				 TALLOC_CTX *mem_ctx,
				 struct policy_handle *_domain_handle /* [in] [ref] */,
				 uint32_t _num_names /* [in] [range(0,1000)] */,
				 struct lsa_String *_names /* [in] [length_is(num_names),size_is(1000)] */,
				 struct samr_Ids *_rids /* [out] [ref] */,
				 struct samr_Ids *_types /* [out] [ref] */,
				 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_LOOKUPNAMES_COMPAT */

struct tevent_req *dcerpc_samr_LookupRids_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_LookupRids *r);
NTSTATUS dcerpc_samr_LookupRids_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_LookupRids_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_LookupRids *r);
#ifdef DCERPC_CALL_SAMR_LOOKUPRIDS_COMPAT
#define dcerpc_samr_LookupRids(p, m, r) dcerpc_samr_LookupRids_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_LOOKUPRIDS_COMPAT */
NTSTATUS dcerpc_samr_LookupRids_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_LookupRids *r);
struct tevent_req *dcerpc_samr_LookupRids_send(TALLOC_CTX *mem_ctx,
					       struct tevent_context *ev,
					       struct dcerpc_binding_handle *h,
					       struct policy_handle *_domain_handle /* [in] [ref] */,
					       uint32_t _num_rids /* [in] [range(0,1000)] */,
					       uint32_t *_rids /* [in] [length_is(num_rids),size_is(1000)] */,
					       struct lsa_Strings *_names /* [out] [ref] */,
					       struct samr_Ids *_types /* [out] [ref] */);
NTSTATUS dcerpc_samr_LookupRids_recv(struct tevent_req *req,
				     TALLOC_CTX *mem_ctx,
				     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_LOOKUPRIDS_COMPAT
NTSTATUS dcerpc_samr_LookupRids(struct dcerpc_binding_handle *h,
				TALLOC_CTX *mem_ctx,
				struct policy_handle *_domain_handle /* [in] [ref] */,
				uint32_t _num_rids /* [in] [range(0,1000)] */,
				uint32_t *_rids /* [in] [length_is(num_rids),size_is(1000)] */,
				struct lsa_Strings *_names /* [out] [ref] */,
				struct samr_Ids *_types /* [out] [ref] */,
				NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_LOOKUPRIDS_COMPAT */

struct tevent_req *dcerpc_samr_OpenGroup_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_OpenGroup *r);
NTSTATUS dcerpc_samr_OpenGroup_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_OpenGroup_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_OpenGroup *r);
#ifdef DCERPC_CALL_SAMR_OPENGROUP_COMPAT
#define dcerpc_samr_OpenGroup(p, m, r) dcerpc_samr_OpenGroup_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_OPENGROUP_COMPAT */
NTSTATUS dcerpc_samr_OpenGroup_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_OpenGroup *r);
struct tevent_req *dcerpc_samr_OpenGroup_send(TALLOC_CTX *mem_ctx,
					      struct tevent_context *ev,
					      struct dcerpc_binding_handle *h,
					      struct policy_handle *_domain_handle /* [in] [ref] */,
					      uint32_t _access_mask /* [in]  */,
					      uint32_t _rid /* [in]  */,
					      struct policy_handle *_group_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_OpenGroup_recv(struct tevent_req *req,
				    TALLOC_CTX *mem_ctx,
				    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_OPENGROUP_COMPAT
NTSTATUS dcerpc_samr_OpenGroup(struct dcerpc_binding_handle *h,
			       TALLOC_CTX *mem_ctx,
			       struct policy_handle *_domain_handle /* [in] [ref] */,
			       uint32_t _access_mask /* [in]  */,
			       uint32_t _rid /* [in]  */,
			       struct policy_handle *_group_handle /* [out] [ref] */,
			       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_OPENGROUP_COMPAT */

struct tevent_req *dcerpc_samr_QueryGroupInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryGroupInfo *r);
NTSTATUS dcerpc_samr_QueryGroupInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryGroupInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryGroupInfo *r);
#ifdef DCERPC_CALL_SAMR_QUERYGROUPINFO_COMPAT
#define dcerpc_samr_QueryGroupInfo(p, m, r) dcerpc_samr_QueryGroupInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYGROUPINFO_COMPAT */
NTSTATUS dcerpc_samr_QueryGroupInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryGroupInfo *r);
struct tevent_req *dcerpc_samr_QueryGroupInfo_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_group_handle /* [in] [ref] */,
						   enum samr_GroupInfoEnum _level /* [in]  */,
						   union samr_GroupInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryGroupInfo_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYGROUPINFO_COMPAT
NTSTATUS dcerpc_samr_QueryGroupInfo(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_group_handle /* [in] [ref] */,
				    enum samr_GroupInfoEnum _level /* [in]  */,
				    union samr_GroupInfo **_info /* [out] [ref,switch_is(level)] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYGROUPINFO_COMPAT */

struct tevent_req *dcerpc_samr_SetGroupInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetGroupInfo *r);
NTSTATUS dcerpc_samr_SetGroupInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetGroupInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetGroupInfo *r);
#ifdef DCERPC_CALL_SAMR_SETGROUPINFO_COMPAT
#define dcerpc_samr_SetGroupInfo(p, m, r) dcerpc_samr_SetGroupInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETGROUPINFO_COMPAT */
NTSTATUS dcerpc_samr_SetGroupInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetGroupInfo *r);
struct tevent_req *dcerpc_samr_SetGroupInfo_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct dcerpc_binding_handle *h,
						 struct policy_handle *_group_handle /* [in] [ref] */,
						 enum samr_GroupInfoEnum _level /* [in]  */,
						 union samr_GroupInfo *_info /* [in] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_SetGroupInfo_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETGROUPINFO_COMPAT
NTSTATUS dcerpc_samr_SetGroupInfo(struct dcerpc_binding_handle *h,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *_group_handle /* [in] [ref] */,
				  enum samr_GroupInfoEnum _level /* [in]  */,
				  union samr_GroupInfo *_info /* [in] [ref,switch_is(level)] */,
				  NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETGROUPINFO_COMPAT */

struct tevent_req *dcerpc_samr_AddGroupMember_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_AddGroupMember *r);
NTSTATUS dcerpc_samr_AddGroupMember_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_AddGroupMember_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_AddGroupMember *r);
#ifdef DCERPC_CALL_SAMR_ADDGROUPMEMBER_COMPAT
#define dcerpc_samr_AddGroupMember(p, m, r) dcerpc_samr_AddGroupMember_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ADDGROUPMEMBER_COMPAT */
NTSTATUS dcerpc_samr_AddGroupMember_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_AddGroupMember *r);
struct tevent_req *dcerpc_samr_AddGroupMember_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_group_handle /* [in] [ref] */,
						   uint32_t _rid /* [in]  */,
						   uint32_t _flags /* [in]  */);
NTSTATUS dcerpc_samr_AddGroupMember_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ADDGROUPMEMBER_COMPAT
NTSTATUS dcerpc_samr_AddGroupMember(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_group_handle /* [in] [ref] */,
				    uint32_t _rid /* [in]  */,
				    uint32_t _flags /* [in]  */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ADDGROUPMEMBER_COMPAT */

struct tevent_req *dcerpc_samr_DeleteDomainGroup_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_DeleteDomainGroup *r);
NTSTATUS dcerpc_samr_DeleteDomainGroup_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_DeleteDomainGroup_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_DeleteDomainGroup *r);
#ifdef DCERPC_CALL_SAMR_DELETEDOMAINGROUP_COMPAT
#define dcerpc_samr_DeleteDomainGroup(p, m, r) dcerpc_samr_DeleteDomainGroup_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_DELETEDOMAINGROUP_COMPAT */
NTSTATUS dcerpc_samr_DeleteDomainGroup_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_DeleteDomainGroup *r);
struct tevent_req *dcerpc_samr_DeleteDomainGroup_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_group_handle /* [in,out] [ref] */);
NTSTATUS dcerpc_samr_DeleteDomainGroup_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_DELETEDOMAINGROUP_COMPAT
NTSTATUS dcerpc_samr_DeleteDomainGroup(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_group_handle /* [in,out] [ref] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_DELETEDOMAINGROUP_COMPAT */

struct tevent_req *dcerpc_samr_DeleteGroupMember_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_DeleteGroupMember *r);
NTSTATUS dcerpc_samr_DeleteGroupMember_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_DeleteGroupMember_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_DeleteGroupMember *r);
#ifdef DCERPC_CALL_SAMR_DELETEGROUPMEMBER_COMPAT
#define dcerpc_samr_DeleteGroupMember(p, m, r) dcerpc_samr_DeleteGroupMember_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_DELETEGROUPMEMBER_COMPAT */
NTSTATUS dcerpc_samr_DeleteGroupMember_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_DeleteGroupMember *r);
struct tevent_req *dcerpc_samr_DeleteGroupMember_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_group_handle /* [in] [ref] */,
						      uint32_t _rid /* [in]  */);
NTSTATUS dcerpc_samr_DeleteGroupMember_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_DELETEGROUPMEMBER_COMPAT
NTSTATUS dcerpc_samr_DeleteGroupMember(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_group_handle /* [in] [ref] */,
				       uint32_t _rid /* [in]  */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_DELETEGROUPMEMBER_COMPAT */

struct tevent_req *dcerpc_samr_QueryGroupMember_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryGroupMember *r);
NTSTATUS dcerpc_samr_QueryGroupMember_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryGroupMember_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryGroupMember *r);
#ifdef DCERPC_CALL_SAMR_QUERYGROUPMEMBER_COMPAT
#define dcerpc_samr_QueryGroupMember(p, m, r) dcerpc_samr_QueryGroupMember_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYGROUPMEMBER_COMPAT */
NTSTATUS dcerpc_samr_QueryGroupMember_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryGroupMember *r);
struct tevent_req *dcerpc_samr_QueryGroupMember_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     struct policy_handle *_group_handle /* [in] [ref] */,
						     struct samr_RidTypeArray **_rids /* [out] [ref] */);
NTSTATUS dcerpc_samr_QueryGroupMember_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYGROUPMEMBER_COMPAT
NTSTATUS dcerpc_samr_QueryGroupMember(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      struct policy_handle *_group_handle /* [in] [ref] */,
				      struct samr_RidTypeArray **_rids /* [out] [ref] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYGROUPMEMBER_COMPAT */

struct tevent_req *dcerpc_samr_SetMemberAttributesOfGroup_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetMemberAttributesOfGroup *r);
NTSTATUS dcerpc_samr_SetMemberAttributesOfGroup_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetMemberAttributesOfGroup_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetMemberAttributesOfGroup *r);
#ifdef DCERPC_CALL_SAMR_SETMEMBERATTRIBUTESOFGROUP_COMPAT
#define dcerpc_samr_SetMemberAttributesOfGroup(p, m, r) dcerpc_samr_SetMemberAttributesOfGroup_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETMEMBERATTRIBUTESOFGROUP_COMPAT */
NTSTATUS dcerpc_samr_SetMemberAttributesOfGroup_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetMemberAttributesOfGroup *r);
struct tevent_req *dcerpc_samr_SetMemberAttributesOfGroup_send(TALLOC_CTX *mem_ctx,
							       struct tevent_context *ev,
							       struct dcerpc_binding_handle *h,
							       struct policy_handle *_group_handle /* [in] [ref] */,
							       uint32_t _unknown1 /* [in]  */,
							       uint32_t _unknown2 /* [in]  */);
NTSTATUS dcerpc_samr_SetMemberAttributesOfGroup_recv(struct tevent_req *req,
						     TALLOC_CTX *mem_ctx,
						     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETMEMBERATTRIBUTESOFGROUP_COMPAT
NTSTATUS dcerpc_samr_SetMemberAttributesOfGroup(struct dcerpc_binding_handle *h,
						TALLOC_CTX *mem_ctx,
						struct policy_handle *_group_handle /* [in] [ref] */,
						uint32_t _unknown1 /* [in]  */,
						uint32_t _unknown2 /* [in]  */,
						NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETMEMBERATTRIBUTESOFGROUP_COMPAT */

struct tevent_req *dcerpc_samr_OpenAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_OpenAlias *r);
NTSTATUS dcerpc_samr_OpenAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_OpenAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_OpenAlias *r);
#ifdef DCERPC_CALL_SAMR_OPENALIAS_COMPAT
#define dcerpc_samr_OpenAlias(p, m, r) dcerpc_samr_OpenAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_OPENALIAS_COMPAT */
NTSTATUS dcerpc_samr_OpenAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_OpenAlias *r);
struct tevent_req *dcerpc_samr_OpenAlias_send(TALLOC_CTX *mem_ctx,
					      struct tevent_context *ev,
					      struct dcerpc_binding_handle *h,
					      struct policy_handle *_domain_handle /* [in] [ref] */,
					      uint32_t _access_mask /* [in]  */,
					      uint32_t _rid /* [in]  */,
					      struct policy_handle *_alias_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_OpenAlias_recv(struct tevent_req *req,
				    TALLOC_CTX *mem_ctx,
				    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_OPENALIAS_COMPAT
NTSTATUS dcerpc_samr_OpenAlias(struct dcerpc_binding_handle *h,
			       TALLOC_CTX *mem_ctx,
			       struct policy_handle *_domain_handle /* [in] [ref] */,
			       uint32_t _access_mask /* [in]  */,
			       uint32_t _rid /* [in]  */,
			       struct policy_handle *_alias_handle /* [out] [ref] */,
			       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_OPENALIAS_COMPAT */

struct tevent_req *dcerpc_samr_QueryAliasInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryAliasInfo *r);
NTSTATUS dcerpc_samr_QueryAliasInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryAliasInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryAliasInfo *r);
#ifdef DCERPC_CALL_SAMR_QUERYALIASINFO_COMPAT
#define dcerpc_samr_QueryAliasInfo(p, m, r) dcerpc_samr_QueryAliasInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYALIASINFO_COMPAT */
NTSTATUS dcerpc_samr_QueryAliasInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryAliasInfo *r);
struct tevent_req *dcerpc_samr_QueryAliasInfo_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_alias_handle /* [in] [ref] */,
						   enum samr_AliasInfoEnum _level /* [in]  */,
						   union samr_AliasInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryAliasInfo_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYALIASINFO_COMPAT
NTSTATUS dcerpc_samr_QueryAliasInfo(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_alias_handle /* [in] [ref] */,
				    enum samr_AliasInfoEnum _level /* [in]  */,
				    union samr_AliasInfo **_info /* [out] [ref,switch_is(level)] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYALIASINFO_COMPAT */

struct tevent_req *dcerpc_samr_SetAliasInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetAliasInfo *r);
NTSTATUS dcerpc_samr_SetAliasInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetAliasInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetAliasInfo *r);
#ifdef DCERPC_CALL_SAMR_SETALIASINFO_COMPAT
#define dcerpc_samr_SetAliasInfo(p, m, r) dcerpc_samr_SetAliasInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETALIASINFO_COMPAT */
NTSTATUS dcerpc_samr_SetAliasInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetAliasInfo *r);
struct tevent_req *dcerpc_samr_SetAliasInfo_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct dcerpc_binding_handle *h,
						 struct policy_handle *_alias_handle /* [in] [ref] */,
						 enum samr_AliasInfoEnum _level /* [in]  */,
						 union samr_AliasInfo *_info /* [in] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_SetAliasInfo_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETALIASINFO_COMPAT
NTSTATUS dcerpc_samr_SetAliasInfo(struct dcerpc_binding_handle *h,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *_alias_handle /* [in] [ref] */,
				  enum samr_AliasInfoEnum _level /* [in]  */,
				  union samr_AliasInfo *_info /* [in] [ref,switch_is(level)] */,
				  NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETALIASINFO_COMPAT */

struct tevent_req *dcerpc_samr_DeleteDomAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_DeleteDomAlias *r);
NTSTATUS dcerpc_samr_DeleteDomAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_DeleteDomAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_DeleteDomAlias *r);
#ifdef DCERPC_CALL_SAMR_DELETEDOMALIAS_COMPAT
#define dcerpc_samr_DeleteDomAlias(p, m, r) dcerpc_samr_DeleteDomAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_DELETEDOMALIAS_COMPAT */
NTSTATUS dcerpc_samr_DeleteDomAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_DeleteDomAlias *r);
struct tevent_req *dcerpc_samr_DeleteDomAlias_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_alias_handle /* [in,out] [ref] */);
NTSTATUS dcerpc_samr_DeleteDomAlias_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_DELETEDOMALIAS_COMPAT
NTSTATUS dcerpc_samr_DeleteDomAlias(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_alias_handle /* [in,out] [ref] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_DELETEDOMALIAS_COMPAT */

struct tevent_req *dcerpc_samr_AddAliasMember_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_AddAliasMember *r);
NTSTATUS dcerpc_samr_AddAliasMember_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_AddAliasMember_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_AddAliasMember *r);
#ifdef DCERPC_CALL_SAMR_ADDALIASMEMBER_COMPAT
#define dcerpc_samr_AddAliasMember(p, m, r) dcerpc_samr_AddAliasMember_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ADDALIASMEMBER_COMPAT */
NTSTATUS dcerpc_samr_AddAliasMember_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_AddAliasMember *r);
struct tevent_req *dcerpc_samr_AddAliasMember_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_alias_handle /* [in] [ref] */,
						   struct dom_sid2 *_sid /* [in] [ref] */);
NTSTATUS dcerpc_samr_AddAliasMember_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ADDALIASMEMBER_COMPAT
NTSTATUS dcerpc_samr_AddAliasMember(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_alias_handle /* [in] [ref] */,
				    struct dom_sid2 *_sid /* [in] [ref] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ADDALIASMEMBER_COMPAT */

struct tevent_req *dcerpc_samr_DeleteAliasMember_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_DeleteAliasMember *r);
NTSTATUS dcerpc_samr_DeleteAliasMember_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_DeleteAliasMember_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_DeleteAliasMember *r);
#ifdef DCERPC_CALL_SAMR_DELETEALIASMEMBER_COMPAT
#define dcerpc_samr_DeleteAliasMember(p, m, r) dcerpc_samr_DeleteAliasMember_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_DELETEALIASMEMBER_COMPAT */
NTSTATUS dcerpc_samr_DeleteAliasMember_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_DeleteAliasMember *r);
struct tevent_req *dcerpc_samr_DeleteAliasMember_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_alias_handle /* [in] [ref] */,
						      struct dom_sid2 *_sid /* [in] [ref] */);
NTSTATUS dcerpc_samr_DeleteAliasMember_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_DELETEALIASMEMBER_COMPAT
NTSTATUS dcerpc_samr_DeleteAliasMember(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_alias_handle /* [in] [ref] */,
				       struct dom_sid2 *_sid /* [in] [ref] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_DELETEALIASMEMBER_COMPAT */

struct tevent_req *dcerpc_samr_GetMembersInAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetMembersInAlias *r);
NTSTATUS dcerpc_samr_GetMembersInAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetMembersInAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetMembersInAlias *r);
#ifdef DCERPC_CALL_SAMR_GETMEMBERSINALIAS_COMPAT
#define dcerpc_samr_GetMembersInAlias(p, m, r) dcerpc_samr_GetMembersInAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETMEMBERSINALIAS_COMPAT */
NTSTATUS dcerpc_samr_GetMembersInAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetMembersInAlias *r);
struct tevent_req *dcerpc_samr_GetMembersInAlias_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_alias_handle /* [in] [ref] */,
						      struct lsa_SidArray *_sids /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetMembersInAlias_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETMEMBERSINALIAS_COMPAT
NTSTATUS dcerpc_samr_GetMembersInAlias(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_alias_handle /* [in] [ref] */,
				       struct lsa_SidArray *_sids /* [out] [ref] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETMEMBERSINALIAS_COMPAT */

struct tevent_req *dcerpc_samr_OpenUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_OpenUser *r);
NTSTATUS dcerpc_samr_OpenUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_OpenUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_OpenUser *r);
#ifdef DCERPC_CALL_SAMR_OPENUSER_COMPAT
#define dcerpc_samr_OpenUser(p, m, r) dcerpc_samr_OpenUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_OPENUSER_COMPAT */
NTSTATUS dcerpc_samr_OpenUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_OpenUser *r);
struct tevent_req *dcerpc_samr_OpenUser_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     struct policy_handle *_domain_handle /* [in] [ref] */,
					     uint32_t _access_mask /* [in]  */,
					     uint32_t _rid /* [in]  */,
					     struct policy_handle *_user_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_OpenUser_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_OPENUSER_COMPAT
NTSTATUS dcerpc_samr_OpenUser(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      struct policy_handle *_domain_handle /* [in] [ref] */,
			      uint32_t _access_mask /* [in]  */,
			      uint32_t _rid /* [in]  */,
			      struct policy_handle *_user_handle /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_OPENUSER_COMPAT */

struct tevent_req *dcerpc_samr_DeleteUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_DeleteUser *r);
NTSTATUS dcerpc_samr_DeleteUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_DeleteUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_DeleteUser *r);
#ifdef DCERPC_CALL_SAMR_DELETEUSER_COMPAT
#define dcerpc_samr_DeleteUser(p, m, r) dcerpc_samr_DeleteUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_DELETEUSER_COMPAT */
NTSTATUS dcerpc_samr_DeleteUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_DeleteUser *r);
struct tevent_req *dcerpc_samr_DeleteUser_send(TALLOC_CTX *mem_ctx,
					       struct tevent_context *ev,
					       struct dcerpc_binding_handle *h,
					       struct policy_handle *_user_handle /* [in,out] [ref] */);
NTSTATUS dcerpc_samr_DeleteUser_recv(struct tevent_req *req,
				     TALLOC_CTX *mem_ctx,
				     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_DELETEUSER_COMPAT
NTSTATUS dcerpc_samr_DeleteUser(struct dcerpc_binding_handle *h,
				TALLOC_CTX *mem_ctx,
				struct policy_handle *_user_handle /* [in,out] [ref] */,
				NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_DELETEUSER_COMPAT */

struct tevent_req *dcerpc_samr_QueryUserInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryUserInfo *r);
NTSTATUS dcerpc_samr_QueryUserInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryUserInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryUserInfo *r);
#ifdef DCERPC_CALL_SAMR_QUERYUSERINFO_COMPAT
#define dcerpc_samr_QueryUserInfo(p, m, r) dcerpc_samr_QueryUserInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYUSERINFO_COMPAT */
NTSTATUS dcerpc_samr_QueryUserInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryUserInfo *r);
struct tevent_req *dcerpc_samr_QueryUserInfo_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct dcerpc_binding_handle *h,
						  struct policy_handle *_user_handle /* [in] [ref] */,
						  enum samr_UserInfoLevel _level /* [in]  */,
						  union samr_UserInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryUserInfo_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYUSERINFO_COMPAT
NTSTATUS dcerpc_samr_QueryUserInfo(struct dcerpc_binding_handle *h,
				   TALLOC_CTX *mem_ctx,
				   struct policy_handle *_user_handle /* [in] [ref] */,
				   enum samr_UserInfoLevel _level /* [in]  */,
				   union samr_UserInfo **_info /* [out] [ref,switch_is(level)] */,
				   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYUSERINFO_COMPAT */

struct tevent_req *dcerpc_samr_SetUserInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetUserInfo *r);
NTSTATUS dcerpc_samr_SetUserInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetUserInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetUserInfo *r);
#ifdef DCERPC_CALL_SAMR_SETUSERINFO_COMPAT
#define dcerpc_samr_SetUserInfo(p, m, r) dcerpc_samr_SetUserInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETUSERINFO_COMPAT */
NTSTATUS dcerpc_samr_SetUserInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetUserInfo *r);
struct tevent_req *dcerpc_samr_SetUserInfo_send(TALLOC_CTX *mem_ctx,
						struct tevent_context *ev,
						struct dcerpc_binding_handle *h,
						struct policy_handle *_user_handle /* [in] [ref] */,
						enum samr_UserInfoLevel _level /* [in]  */,
						union samr_UserInfo *_info /* [in] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_SetUserInfo_recv(struct tevent_req *req,
				      TALLOC_CTX *mem_ctx,
				      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETUSERINFO_COMPAT
NTSTATUS dcerpc_samr_SetUserInfo(struct dcerpc_binding_handle *h,
				 TALLOC_CTX *mem_ctx,
				 struct policy_handle *_user_handle /* [in] [ref] */,
				 enum samr_UserInfoLevel _level /* [in]  */,
				 union samr_UserInfo *_info /* [in] [ref,switch_is(level)] */,
				 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETUSERINFO_COMPAT */

struct tevent_req *dcerpc_samr_ChangePasswordUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_ChangePasswordUser *r);
NTSTATUS dcerpc_samr_ChangePasswordUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_ChangePasswordUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser *r);
#ifdef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER_COMPAT
#define dcerpc_samr_ChangePasswordUser(p, m, r) dcerpc_samr_ChangePasswordUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER_COMPAT */
NTSTATUS dcerpc_samr_ChangePasswordUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser *r);
struct tevent_req *dcerpc_samr_ChangePasswordUser_send(TALLOC_CTX *mem_ctx,
						       struct tevent_context *ev,
						       struct dcerpc_binding_handle *h,
						       struct policy_handle *_user_handle /* [in] [ref] */,
						       uint8_t _lm_present /* [in]  */,
						       struct samr_Password *_old_lm_crypted /* [in] [unique] */,
						       struct samr_Password *_new_lm_crypted /* [in] [unique] */,
						       uint8_t _nt_present /* [in]  */,
						       struct samr_Password *_old_nt_crypted /* [in] [unique] */,
						       struct samr_Password *_new_nt_crypted /* [in] [unique] */,
						       uint8_t _cross1_present /* [in]  */,
						       struct samr_Password *_nt_cross /* [in] [unique] */,
						       uint8_t _cross2_present /* [in]  */,
						       struct samr_Password *_lm_cross /* [in] [unique] */);
NTSTATUS dcerpc_samr_ChangePasswordUser_recv(struct tevent_req *req,
					     TALLOC_CTX *mem_ctx,
					     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER_COMPAT
NTSTATUS dcerpc_samr_ChangePasswordUser(struct dcerpc_binding_handle *h,
					TALLOC_CTX *mem_ctx,
					struct policy_handle *_user_handle /* [in] [ref] */,
					uint8_t _lm_present /* [in]  */,
					struct samr_Password *_old_lm_crypted /* [in] [unique] */,
					struct samr_Password *_new_lm_crypted /* [in] [unique] */,
					uint8_t _nt_present /* [in]  */,
					struct samr_Password *_old_nt_crypted /* [in] [unique] */,
					struct samr_Password *_new_nt_crypted /* [in] [unique] */,
					uint8_t _cross1_present /* [in]  */,
					struct samr_Password *_nt_cross /* [in] [unique] */,
					uint8_t _cross2_present /* [in]  */,
					struct samr_Password *_lm_cross /* [in] [unique] */,
					NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER_COMPAT */

struct tevent_req *dcerpc_samr_GetGroupsForUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetGroupsForUser *r);
NTSTATUS dcerpc_samr_GetGroupsForUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetGroupsForUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetGroupsForUser *r);
#ifdef DCERPC_CALL_SAMR_GETGROUPSFORUSER_COMPAT
#define dcerpc_samr_GetGroupsForUser(p, m, r) dcerpc_samr_GetGroupsForUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETGROUPSFORUSER_COMPAT */
NTSTATUS dcerpc_samr_GetGroupsForUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetGroupsForUser *r);
struct tevent_req *dcerpc_samr_GetGroupsForUser_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     struct policy_handle *_user_handle /* [in] [ref] */,
						     struct samr_RidWithAttributeArray **_rids /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetGroupsForUser_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETGROUPSFORUSER_COMPAT
NTSTATUS dcerpc_samr_GetGroupsForUser(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      struct policy_handle *_user_handle /* [in] [ref] */,
				      struct samr_RidWithAttributeArray **_rids /* [out] [ref] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETGROUPSFORUSER_COMPAT */

struct tevent_req *dcerpc_samr_QueryDisplayInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryDisplayInfo *r);
NTSTATUS dcerpc_samr_QueryDisplayInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryDisplayInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo *r);
#ifdef DCERPC_CALL_SAMR_QUERYDISPLAYINFO_COMPAT
#define dcerpc_samr_QueryDisplayInfo(p, m, r) dcerpc_samr_QueryDisplayInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO_COMPAT */
NTSTATUS dcerpc_samr_QueryDisplayInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo *r);
struct tevent_req *dcerpc_samr_QueryDisplayInfo_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     struct policy_handle *_domain_handle /* [in] [ref] */,
						     uint16_t _level /* [in]  */,
						     uint32_t _start_idx /* [in]  */,
						     uint32_t _max_entries /* [in]  */,
						     uint32_t _buf_size /* [in]  */,
						     uint32_t *_total_size /* [out] [ref] */,
						     uint32_t *_returned_size /* [out] [ref] */,
						     union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryDisplayInfo_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYDISPLAYINFO_COMPAT
NTSTATUS dcerpc_samr_QueryDisplayInfo(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      struct policy_handle *_domain_handle /* [in] [ref] */,
				      uint16_t _level /* [in]  */,
				      uint32_t _start_idx /* [in]  */,
				      uint32_t _max_entries /* [in]  */,
				      uint32_t _buf_size /* [in]  */,
				      uint32_t *_total_size /* [out] [ref] */,
				      uint32_t *_returned_size /* [out] [ref] */,
				      union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO_COMPAT */

struct tevent_req *dcerpc_samr_GetDisplayEnumerationIndex_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetDisplayEnumerationIndex *r);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetDisplayEnumerationIndex *r);
#ifdef DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX_COMPAT
#define dcerpc_samr_GetDisplayEnumerationIndex(p, m, r) dcerpc_samr_GetDisplayEnumerationIndex_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX_COMPAT */
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetDisplayEnumerationIndex *r);
struct tevent_req *dcerpc_samr_GetDisplayEnumerationIndex_send(TALLOC_CTX *mem_ctx,
							       struct tevent_context *ev,
							       struct dcerpc_binding_handle *h,
							       struct policy_handle *_domain_handle /* [in] [ref] */,
							       uint16_t _level /* [in]  */,
							       struct lsa_String *_name /* [in] [ref] */,
							       uint32_t *_idx /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex_recv(struct tevent_req *req,
						     TALLOC_CTX *mem_ctx,
						     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX_COMPAT
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex(struct dcerpc_binding_handle *h,
						TALLOC_CTX *mem_ctx,
						struct policy_handle *_domain_handle /* [in] [ref] */,
						uint16_t _level /* [in]  */,
						struct lsa_String *_name /* [in] [ref] */,
						uint32_t *_idx /* [out] [ref] */,
						NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX_COMPAT */

struct tevent_req *dcerpc_samr_TestPrivateFunctionsDomain_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_TestPrivateFunctionsDomain *r);
NTSTATUS dcerpc_samr_TestPrivateFunctionsDomain_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_TestPrivateFunctionsDomain_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_TestPrivateFunctionsDomain *r);
#ifdef DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSDOMAIN_COMPAT
#define dcerpc_samr_TestPrivateFunctionsDomain(p, m, r) dcerpc_samr_TestPrivateFunctionsDomain_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSDOMAIN_COMPAT */
NTSTATUS dcerpc_samr_TestPrivateFunctionsDomain_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_TestPrivateFunctionsDomain *r);
struct tevent_req *dcerpc_samr_TestPrivateFunctionsDomain_send(TALLOC_CTX *mem_ctx,
							       struct tevent_context *ev,
							       struct dcerpc_binding_handle *h,
							       struct policy_handle *_domain_handle /* [in] [ref] */);
NTSTATUS dcerpc_samr_TestPrivateFunctionsDomain_recv(struct tevent_req *req,
						     TALLOC_CTX *mem_ctx,
						     NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSDOMAIN_COMPAT
NTSTATUS dcerpc_samr_TestPrivateFunctionsDomain(struct dcerpc_binding_handle *h,
						TALLOC_CTX *mem_ctx,
						struct policy_handle *_domain_handle /* [in] [ref] */,
						NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSDOMAIN_COMPAT */

struct tevent_req *dcerpc_samr_TestPrivateFunctionsUser_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_TestPrivateFunctionsUser *r);
NTSTATUS dcerpc_samr_TestPrivateFunctionsUser_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_TestPrivateFunctionsUser_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_TestPrivateFunctionsUser *r);
#ifdef DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSUSER_COMPAT
#define dcerpc_samr_TestPrivateFunctionsUser(p, m, r) dcerpc_samr_TestPrivateFunctionsUser_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSUSER_COMPAT */
NTSTATUS dcerpc_samr_TestPrivateFunctionsUser_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_TestPrivateFunctionsUser *r);
struct tevent_req *dcerpc_samr_TestPrivateFunctionsUser_send(TALLOC_CTX *mem_ctx,
							     struct tevent_context *ev,
							     struct dcerpc_binding_handle *h,
							     struct policy_handle *_user_handle /* [in] [ref] */);
NTSTATUS dcerpc_samr_TestPrivateFunctionsUser_recv(struct tevent_req *req,
						   TALLOC_CTX *mem_ctx,
						   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSUSER_COMPAT
NTSTATUS dcerpc_samr_TestPrivateFunctionsUser(struct dcerpc_binding_handle *h,
					      TALLOC_CTX *mem_ctx,
					      struct policy_handle *_user_handle /* [in] [ref] */,
					      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_TESTPRIVATEFUNCTIONSUSER_COMPAT */

struct tevent_req *dcerpc_samr_GetUserPwInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetUserPwInfo *r);
NTSTATUS dcerpc_samr_GetUserPwInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetUserPwInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetUserPwInfo *r);
#ifdef DCERPC_CALL_SAMR_GETUSERPWINFO_COMPAT
#define dcerpc_samr_GetUserPwInfo(p, m, r) dcerpc_samr_GetUserPwInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETUSERPWINFO_COMPAT */
NTSTATUS dcerpc_samr_GetUserPwInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetUserPwInfo *r);
struct tevent_req *dcerpc_samr_GetUserPwInfo_send(TALLOC_CTX *mem_ctx,
						  struct tevent_context *ev,
						  struct dcerpc_binding_handle *h,
						  struct policy_handle *_user_handle /* [in] [ref] */,
						  struct samr_PwInfo *_info /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetUserPwInfo_recv(struct tevent_req *req,
					TALLOC_CTX *mem_ctx,
					NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETUSERPWINFO_COMPAT
NTSTATUS dcerpc_samr_GetUserPwInfo(struct dcerpc_binding_handle *h,
				   TALLOC_CTX *mem_ctx,
				   struct policy_handle *_user_handle /* [in] [ref] */,
				   struct samr_PwInfo *_info /* [out] [ref] */,
				   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETUSERPWINFO_COMPAT */

struct tevent_req *dcerpc_samr_RemoveMemberFromForeignDomain_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_RemoveMemberFromForeignDomain *r);
NTSTATUS dcerpc_samr_RemoveMemberFromForeignDomain_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_RemoveMemberFromForeignDomain_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_RemoveMemberFromForeignDomain *r);
#ifdef DCERPC_CALL_SAMR_REMOVEMEMBERFROMFOREIGNDOMAIN_COMPAT
#define dcerpc_samr_RemoveMemberFromForeignDomain(p, m, r) dcerpc_samr_RemoveMemberFromForeignDomain_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_REMOVEMEMBERFROMFOREIGNDOMAIN_COMPAT */
NTSTATUS dcerpc_samr_RemoveMemberFromForeignDomain_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_RemoveMemberFromForeignDomain *r);
struct tevent_req *dcerpc_samr_RemoveMemberFromForeignDomain_send(TALLOC_CTX *mem_ctx,
								  struct tevent_context *ev,
								  struct dcerpc_binding_handle *h,
								  struct policy_handle *_domain_handle /* [in] [ref] */,
								  struct dom_sid2 *_sid /* [in] [ref] */);
NTSTATUS dcerpc_samr_RemoveMemberFromForeignDomain_recv(struct tevent_req *req,
							TALLOC_CTX *mem_ctx,
							NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_REMOVEMEMBERFROMFOREIGNDOMAIN_COMPAT
NTSTATUS dcerpc_samr_RemoveMemberFromForeignDomain(struct dcerpc_binding_handle *h,
						   TALLOC_CTX *mem_ctx,
						   struct policy_handle *_domain_handle /* [in] [ref] */,
						   struct dom_sid2 *_sid /* [in] [ref] */,
						   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_REMOVEMEMBERFROMFOREIGNDOMAIN_COMPAT */

struct tevent_req *dcerpc_samr_QueryDomainInfo2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryDomainInfo2 *r);
NTSTATUS dcerpc_samr_QueryDomainInfo2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryDomainInfo2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryDomainInfo2 *r);
#ifdef DCERPC_CALL_SAMR_QUERYDOMAININFO2_COMPAT
#define dcerpc_samr_QueryDomainInfo2(p, m, r) dcerpc_samr_QueryDomainInfo2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYDOMAININFO2_COMPAT */
NTSTATUS dcerpc_samr_QueryDomainInfo2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryDomainInfo2 *r);
struct tevent_req *dcerpc_samr_QueryDomainInfo2_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     struct policy_handle *_domain_handle /* [in] [ref] */,
						     enum samr_DomainInfoClass _level /* [in]  */,
						     union samr_DomainInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryDomainInfo2_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYDOMAININFO2_COMPAT
NTSTATUS dcerpc_samr_QueryDomainInfo2(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      struct policy_handle *_domain_handle /* [in] [ref] */,
				      enum samr_DomainInfoClass _level /* [in]  */,
				      union samr_DomainInfo **_info /* [out] [ref,switch_is(level)] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYDOMAININFO2_COMPAT */

struct tevent_req *dcerpc_samr_QueryUserInfo2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryUserInfo2 *r);
NTSTATUS dcerpc_samr_QueryUserInfo2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryUserInfo2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryUserInfo2 *r);
#ifdef DCERPC_CALL_SAMR_QUERYUSERINFO2_COMPAT
#define dcerpc_samr_QueryUserInfo2(p, m, r) dcerpc_samr_QueryUserInfo2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYUSERINFO2_COMPAT */
NTSTATUS dcerpc_samr_QueryUserInfo2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryUserInfo2 *r);
struct tevent_req *dcerpc_samr_QueryUserInfo2_send(TALLOC_CTX *mem_ctx,
						   struct tevent_context *ev,
						   struct dcerpc_binding_handle *h,
						   struct policy_handle *_user_handle /* [in] [ref] */,
						   enum samr_UserInfoLevel _level /* [in]  */,
						   union samr_UserInfo **_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryUserInfo2_recv(struct tevent_req *req,
					 TALLOC_CTX *mem_ctx,
					 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYUSERINFO2_COMPAT
NTSTATUS dcerpc_samr_QueryUserInfo2(struct dcerpc_binding_handle *h,
				    TALLOC_CTX *mem_ctx,
				    struct policy_handle *_user_handle /* [in] [ref] */,
				    enum samr_UserInfoLevel _level /* [in]  */,
				    union samr_UserInfo **_info /* [out] [ref,switch_is(level)] */,
				    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYUSERINFO2_COMPAT */

struct tevent_req *dcerpc_samr_QueryDisplayInfo2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryDisplayInfo2 *r);
NTSTATUS dcerpc_samr_QueryDisplayInfo2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryDisplayInfo2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo2 *r);
#ifdef DCERPC_CALL_SAMR_QUERYDISPLAYINFO2_COMPAT
#define dcerpc_samr_QueryDisplayInfo2(p, m, r) dcerpc_samr_QueryDisplayInfo2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO2_COMPAT */
NTSTATUS dcerpc_samr_QueryDisplayInfo2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo2 *r);
struct tevent_req *dcerpc_samr_QueryDisplayInfo2_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_domain_handle /* [in] [ref] */,
						      uint16_t _level /* [in]  */,
						      uint32_t _start_idx /* [in]  */,
						      uint32_t _max_entries /* [in]  */,
						      uint32_t _buf_size /* [in]  */,
						      uint32_t *_total_size /* [out] [ref] */,
						      uint32_t *_returned_size /* [out] [ref] */,
						      union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryDisplayInfo2_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYDISPLAYINFO2_COMPAT
NTSTATUS dcerpc_samr_QueryDisplayInfo2(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_domain_handle /* [in] [ref] */,
				       uint16_t _level /* [in]  */,
				       uint32_t _start_idx /* [in]  */,
				       uint32_t _max_entries /* [in]  */,
				       uint32_t _buf_size /* [in]  */,
				       uint32_t *_total_size /* [out] [ref] */,
				       uint32_t *_returned_size /* [out] [ref] */,
				       union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO2_COMPAT */

struct tevent_req *dcerpc_samr_GetDisplayEnumerationIndex2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetDisplayEnumerationIndex2 *r);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetDisplayEnumerationIndex2 *r);
#ifdef DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX2_COMPAT
#define dcerpc_samr_GetDisplayEnumerationIndex2(p, m, r) dcerpc_samr_GetDisplayEnumerationIndex2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX2_COMPAT */
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetDisplayEnumerationIndex2 *r);
struct tevent_req *dcerpc_samr_GetDisplayEnumerationIndex2_send(TALLOC_CTX *mem_ctx,
								struct tevent_context *ev,
								struct dcerpc_binding_handle *h,
								struct policy_handle *_domain_handle /* [in] [ref] */,
								uint16_t _level /* [in]  */,
								struct lsa_String *_name /* [in] [ref] */,
								uint32_t *_idx /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex2_recv(struct tevent_req *req,
						      TALLOC_CTX *mem_ctx,
						      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX2_COMPAT
NTSTATUS dcerpc_samr_GetDisplayEnumerationIndex2(struct dcerpc_binding_handle *h,
						 TALLOC_CTX *mem_ctx,
						 struct policy_handle *_domain_handle /* [in] [ref] */,
						 uint16_t _level /* [in]  */,
						 struct lsa_String *_name /* [in] [ref] */,
						 uint32_t *_idx /* [out] [ref] */,
						 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETDISPLAYENUMERATIONINDEX2_COMPAT */

struct tevent_req *dcerpc_samr_CreateUser2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_CreateUser2 *r);
NTSTATUS dcerpc_samr_CreateUser2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_CreateUser2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_CreateUser2 *r);
#ifdef DCERPC_CALL_SAMR_CREATEUSER2_COMPAT
#define dcerpc_samr_CreateUser2(p, m, r) dcerpc_samr_CreateUser2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CREATEUSER2_COMPAT */
NTSTATUS dcerpc_samr_CreateUser2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_CreateUser2 *r);
struct tevent_req *dcerpc_samr_CreateUser2_send(TALLOC_CTX *mem_ctx,
						struct tevent_context *ev,
						struct dcerpc_binding_handle *h,
						struct policy_handle *_domain_handle /* [in] [ref] */,
						struct lsa_String *_account_name /* [in] [ref] */,
						uint32_t _acct_flags /* [in]  */,
						uint32_t _access_mask /* [in]  */,
						struct policy_handle *_user_handle /* [out] [ref] */,
						uint32_t *_access_granted /* [out] [ref] */,
						uint32_t *_rid /* [out] [ref] */);
NTSTATUS dcerpc_samr_CreateUser2_recv(struct tevent_req *req,
				      TALLOC_CTX *mem_ctx,
				      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CREATEUSER2_COMPAT
NTSTATUS dcerpc_samr_CreateUser2(struct dcerpc_binding_handle *h,
				 TALLOC_CTX *mem_ctx,
				 struct policy_handle *_domain_handle /* [in] [ref] */,
				 struct lsa_String *_account_name /* [in] [ref] */,
				 uint32_t _acct_flags /* [in]  */,
				 uint32_t _access_mask /* [in]  */,
				 struct policy_handle *_user_handle /* [out] [ref] */,
				 uint32_t *_access_granted /* [out] [ref] */,
				 uint32_t *_rid /* [out] [ref] */,
				 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CREATEUSER2_COMPAT */

struct tevent_req *dcerpc_samr_QueryDisplayInfo3_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_QueryDisplayInfo3 *r);
NTSTATUS dcerpc_samr_QueryDisplayInfo3_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_QueryDisplayInfo3_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo3 *r);
#ifdef DCERPC_CALL_SAMR_QUERYDISPLAYINFO3_COMPAT
#define dcerpc_samr_QueryDisplayInfo3(p, m, r) dcerpc_samr_QueryDisplayInfo3_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO3_COMPAT */
NTSTATUS dcerpc_samr_QueryDisplayInfo3_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_QueryDisplayInfo3 *r);
struct tevent_req *dcerpc_samr_QueryDisplayInfo3_send(TALLOC_CTX *mem_ctx,
						      struct tevent_context *ev,
						      struct dcerpc_binding_handle *h,
						      struct policy_handle *_domain_handle /* [in] [ref] */,
						      uint16_t _level /* [in]  */,
						      uint32_t _start_idx /* [in]  */,
						      uint32_t _max_entries /* [in]  */,
						      uint32_t _buf_size /* [in]  */,
						      uint32_t *_total_size /* [out] [ref] */,
						      uint32_t *_returned_size /* [out] [ref] */,
						      union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_QueryDisplayInfo3_recv(struct tevent_req *req,
					    TALLOC_CTX *mem_ctx,
					    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_QUERYDISPLAYINFO3_COMPAT
NTSTATUS dcerpc_samr_QueryDisplayInfo3(struct dcerpc_binding_handle *h,
				       TALLOC_CTX *mem_ctx,
				       struct policy_handle *_domain_handle /* [in] [ref] */,
				       uint16_t _level /* [in]  */,
				       uint32_t _start_idx /* [in]  */,
				       uint32_t _max_entries /* [in]  */,
				       uint32_t _buf_size /* [in]  */,
				       uint32_t *_total_size /* [out] [ref] */,
				       uint32_t *_returned_size /* [out] [ref] */,
				       union samr_DispInfo *_info /* [out] [ref,switch_is(level)] */,
				       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_QUERYDISPLAYINFO3_COMPAT */

struct tevent_req *dcerpc_samr_AddMultipleMembersToAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_AddMultipleMembersToAlias *r);
NTSTATUS dcerpc_samr_AddMultipleMembersToAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_AddMultipleMembersToAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_AddMultipleMembersToAlias *r);
#ifdef DCERPC_CALL_SAMR_ADDMULTIPLEMEMBERSTOALIAS_COMPAT
#define dcerpc_samr_AddMultipleMembersToAlias(p, m, r) dcerpc_samr_AddMultipleMembersToAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_ADDMULTIPLEMEMBERSTOALIAS_COMPAT */
NTSTATUS dcerpc_samr_AddMultipleMembersToAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_AddMultipleMembersToAlias *r);
struct tevent_req *dcerpc_samr_AddMultipleMembersToAlias_send(TALLOC_CTX *mem_ctx,
							      struct tevent_context *ev,
							      struct dcerpc_binding_handle *h,
							      struct policy_handle *_alias_handle /* [in] [ref] */,
							      struct lsa_SidArray *_sids /* [in] [ref] */);
NTSTATUS dcerpc_samr_AddMultipleMembersToAlias_recv(struct tevent_req *req,
						    TALLOC_CTX *mem_ctx,
						    NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_ADDMULTIPLEMEMBERSTOALIAS_COMPAT
NTSTATUS dcerpc_samr_AddMultipleMembersToAlias(struct dcerpc_binding_handle *h,
					       TALLOC_CTX *mem_ctx,
					       struct policy_handle *_alias_handle /* [in] [ref] */,
					       struct lsa_SidArray *_sids /* [in] [ref] */,
					       NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_ADDMULTIPLEMEMBERSTOALIAS_COMPAT */

struct tevent_req *dcerpc_samr_RemoveMultipleMembersFromAlias_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_RemoveMultipleMembersFromAlias *r);
NTSTATUS dcerpc_samr_RemoveMultipleMembersFromAlias_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_RemoveMultipleMembersFromAlias_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_RemoveMultipleMembersFromAlias *r);
#ifdef DCERPC_CALL_SAMR_REMOVEMULTIPLEMEMBERSFROMALIAS_COMPAT
#define dcerpc_samr_RemoveMultipleMembersFromAlias(p, m, r) dcerpc_samr_RemoveMultipleMembersFromAlias_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_REMOVEMULTIPLEMEMBERSFROMALIAS_COMPAT */
NTSTATUS dcerpc_samr_RemoveMultipleMembersFromAlias_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_RemoveMultipleMembersFromAlias *r);
struct tevent_req *dcerpc_samr_RemoveMultipleMembersFromAlias_send(TALLOC_CTX *mem_ctx,
								   struct tevent_context *ev,
								   struct dcerpc_binding_handle *h,
								   struct policy_handle *_alias_handle /* [in] [ref] */,
								   struct lsa_SidArray *_sids /* [in] [ref] */);
NTSTATUS dcerpc_samr_RemoveMultipleMembersFromAlias_recv(struct tevent_req *req,
							 TALLOC_CTX *mem_ctx,
							 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_REMOVEMULTIPLEMEMBERSFROMALIAS_COMPAT
NTSTATUS dcerpc_samr_RemoveMultipleMembersFromAlias(struct dcerpc_binding_handle *h,
						    TALLOC_CTX *mem_ctx,
						    struct policy_handle *_alias_handle /* [in] [ref] */,
						    struct lsa_SidArray *_sids /* [in] [ref] */,
						    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_REMOVEMULTIPLEMEMBERSFROMALIAS_COMPAT */

struct tevent_req *dcerpc_samr_OemChangePasswordUser2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_OemChangePasswordUser2 *r);
NTSTATUS dcerpc_samr_OemChangePasswordUser2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_OemChangePasswordUser2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_OemChangePasswordUser2 *r);
#ifdef DCERPC_CALL_SAMR_OEMCHANGEPASSWORDUSER2_COMPAT
#define dcerpc_samr_OemChangePasswordUser2(p, m, r) dcerpc_samr_OemChangePasswordUser2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_OEMCHANGEPASSWORDUSER2_COMPAT */
NTSTATUS dcerpc_samr_OemChangePasswordUser2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_OemChangePasswordUser2 *r);
struct tevent_req *dcerpc_samr_OemChangePasswordUser2_send(TALLOC_CTX *mem_ctx,
							   struct tevent_context *ev,
							   struct dcerpc_binding_handle *h,
							   struct lsa_AsciiString *_server /* [in] [unique] */,
							   struct lsa_AsciiString *_account /* [in] [ref] */,
							   struct samr_CryptPassword *_password /* [in] [unique] */,
							   struct samr_Password *_hash /* [in] [unique] */);
NTSTATUS dcerpc_samr_OemChangePasswordUser2_recv(struct tevent_req *req,
						 TALLOC_CTX *mem_ctx,
						 NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_OEMCHANGEPASSWORDUSER2_COMPAT
NTSTATUS dcerpc_samr_OemChangePasswordUser2(struct dcerpc_binding_handle *h,
					    TALLOC_CTX *mem_ctx,
					    struct lsa_AsciiString *_server /* [in] [unique] */,
					    struct lsa_AsciiString *_account /* [in] [ref] */,
					    struct samr_CryptPassword *_password /* [in] [unique] */,
					    struct samr_Password *_hash /* [in] [unique] */,
					    NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_OEMCHANGEPASSWORDUSER2_COMPAT */

struct tevent_req *dcerpc_samr_ChangePasswordUser2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_ChangePasswordUser2 *r);
NTSTATUS dcerpc_samr_ChangePasswordUser2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_ChangePasswordUser2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser2 *r);
#ifdef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER2_COMPAT
#define dcerpc_samr_ChangePasswordUser2(p, m, r) dcerpc_samr_ChangePasswordUser2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER2_COMPAT */
NTSTATUS dcerpc_samr_ChangePasswordUser2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser2 *r);
struct tevent_req *dcerpc_samr_ChangePasswordUser2_send(TALLOC_CTX *mem_ctx,
							struct tevent_context *ev,
							struct dcerpc_binding_handle *h,
							struct lsa_String *_server /* [in] [unique] */,
							struct lsa_String *_account /* [in] [ref] */,
							struct samr_CryptPassword *_nt_password /* [in] [unique] */,
							struct samr_Password *_nt_verifier /* [in] [unique] */,
							uint8_t _lm_change /* [in]  */,
							struct samr_CryptPassword *_lm_password /* [in] [unique] */,
							struct samr_Password *_lm_verifier /* [in] [unique] */);
NTSTATUS dcerpc_samr_ChangePasswordUser2_recv(struct tevent_req *req,
					      TALLOC_CTX *mem_ctx,
					      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER2_COMPAT
NTSTATUS dcerpc_samr_ChangePasswordUser2(struct dcerpc_binding_handle *h,
					 TALLOC_CTX *mem_ctx,
					 struct lsa_String *_server /* [in] [unique] */,
					 struct lsa_String *_account /* [in] [ref] */,
					 struct samr_CryptPassword *_nt_password /* [in] [unique] */,
					 struct samr_Password *_nt_verifier /* [in] [unique] */,
					 uint8_t _lm_change /* [in]  */,
					 struct samr_CryptPassword *_lm_password /* [in] [unique] */,
					 struct samr_Password *_lm_verifier /* [in] [unique] */,
					 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER2_COMPAT */

struct tevent_req *dcerpc_samr_GetDomPwInfo_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetDomPwInfo *r);
NTSTATUS dcerpc_samr_GetDomPwInfo_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetDomPwInfo_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetDomPwInfo *r);
#ifdef DCERPC_CALL_SAMR_GETDOMPWINFO_COMPAT
#define dcerpc_samr_GetDomPwInfo(p, m, r) dcerpc_samr_GetDomPwInfo_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETDOMPWINFO_COMPAT */
NTSTATUS dcerpc_samr_GetDomPwInfo_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetDomPwInfo *r);
struct tevent_req *dcerpc_samr_GetDomPwInfo_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct dcerpc_binding_handle *h,
						 struct lsa_String *_domain_name /* [in] [unique] */,
						 struct samr_PwInfo *_info /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetDomPwInfo_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETDOMPWINFO_COMPAT
NTSTATUS dcerpc_samr_GetDomPwInfo(struct dcerpc_binding_handle *h,
				  TALLOC_CTX *mem_ctx,
				  struct lsa_String *_domain_name /* [in] [unique] */,
				  struct samr_PwInfo *_info /* [out] [ref] */,
				  NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETDOMPWINFO_COMPAT */

struct tevent_req *dcerpc_samr_Connect2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Connect2 *r);
NTSTATUS dcerpc_samr_Connect2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Connect2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Connect2 *r);
#ifdef DCERPC_CALL_SAMR_CONNECT2_COMPAT
#define dcerpc_samr_Connect2(p, m, r) dcerpc_samr_Connect2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CONNECT2_COMPAT */
NTSTATUS dcerpc_samr_Connect2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Connect2 *r);
struct tevent_req *dcerpc_samr_Connect2_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     const char *_system_name /* [in] [unique,charset(UTF16)] */,
					     uint32_t _access_mask /* [in]  */,
					     struct policy_handle *_connect_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_Connect2_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CONNECT2_COMPAT
NTSTATUS dcerpc_samr_Connect2(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      const char *_system_name /* [in] [unique,charset(UTF16)] */,
			      uint32_t _access_mask /* [in]  */,
			      struct policy_handle *_connect_handle /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CONNECT2_COMPAT */

struct tevent_req *dcerpc_samr_SetUserInfo2_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetUserInfo2 *r);
NTSTATUS dcerpc_samr_SetUserInfo2_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetUserInfo2_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetUserInfo2 *r);
#ifdef DCERPC_CALL_SAMR_SETUSERINFO2_COMPAT
#define dcerpc_samr_SetUserInfo2(p, m, r) dcerpc_samr_SetUserInfo2_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETUSERINFO2_COMPAT */
NTSTATUS dcerpc_samr_SetUserInfo2_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetUserInfo2 *r);
struct tevent_req *dcerpc_samr_SetUserInfo2_send(TALLOC_CTX *mem_ctx,
						 struct tevent_context *ev,
						 struct dcerpc_binding_handle *h,
						 struct policy_handle *_user_handle /* [in] [ref] */,
						 enum samr_UserInfoLevel _level /* [in]  */,
						 union samr_UserInfo *_info /* [in] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_SetUserInfo2_recv(struct tevent_req *req,
				       TALLOC_CTX *mem_ctx,
				       NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETUSERINFO2_COMPAT
NTSTATUS dcerpc_samr_SetUserInfo2(struct dcerpc_binding_handle *h,
				  TALLOC_CTX *mem_ctx,
				  struct policy_handle *_user_handle /* [in] [ref] */,
				  enum samr_UserInfoLevel _level /* [in]  */,
				  union samr_UserInfo *_info /* [in] [ref,switch_is(level)] */,
				  NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETUSERINFO2_COMPAT */

struct tevent_req *dcerpc_samr_SetBootKeyInformation_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetBootKeyInformation *r);
NTSTATUS dcerpc_samr_SetBootKeyInformation_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetBootKeyInformation_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetBootKeyInformation *r);
#ifdef DCERPC_CALL_SAMR_SETBOOTKEYINFORMATION_COMPAT
#define dcerpc_samr_SetBootKeyInformation(p, m, r) dcerpc_samr_SetBootKeyInformation_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETBOOTKEYINFORMATION_COMPAT */
NTSTATUS dcerpc_samr_SetBootKeyInformation_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetBootKeyInformation *r);
struct tevent_req *dcerpc_samr_SetBootKeyInformation_send(TALLOC_CTX *mem_ctx,
							  struct tevent_context *ev,
							  struct dcerpc_binding_handle *h,
							  struct policy_handle *_connect_handle /* [in] [ref] */,
							  uint32_t _unknown1 /* [in]  */,
							  uint32_t _unknown2 /* [in]  */,
							  uint32_t _unknown3 /* [in]  */);
NTSTATUS dcerpc_samr_SetBootKeyInformation_recv(struct tevent_req *req,
						TALLOC_CTX *mem_ctx,
						NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETBOOTKEYINFORMATION_COMPAT
NTSTATUS dcerpc_samr_SetBootKeyInformation(struct dcerpc_binding_handle *h,
					   TALLOC_CTX *mem_ctx,
					   struct policy_handle *_connect_handle /* [in] [ref] */,
					   uint32_t _unknown1 /* [in]  */,
					   uint32_t _unknown2 /* [in]  */,
					   uint32_t _unknown3 /* [in]  */,
					   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETBOOTKEYINFORMATION_COMPAT */

struct tevent_req *dcerpc_samr_GetBootKeyInformation_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_GetBootKeyInformation *r);
NTSTATUS dcerpc_samr_GetBootKeyInformation_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_GetBootKeyInformation_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_GetBootKeyInformation *r);
#ifdef DCERPC_CALL_SAMR_GETBOOTKEYINFORMATION_COMPAT
#define dcerpc_samr_GetBootKeyInformation(p, m, r) dcerpc_samr_GetBootKeyInformation_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_GETBOOTKEYINFORMATION_COMPAT */
NTSTATUS dcerpc_samr_GetBootKeyInformation_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_GetBootKeyInformation *r);
struct tevent_req *dcerpc_samr_GetBootKeyInformation_send(TALLOC_CTX *mem_ctx,
							  struct tevent_context *ev,
							  struct dcerpc_binding_handle *h,
							  struct policy_handle *_domain_handle /* [in] [ref] */,
							  uint32_t *_unknown /* [out] [ref] */);
NTSTATUS dcerpc_samr_GetBootKeyInformation_recv(struct tevent_req *req,
						TALLOC_CTX *mem_ctx,
						NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_GETBOOTKEYINFORMATION_COMPAT
NTSTATUS dcerpc_samr_GetBootKeyInformation(struct dcerpc_binding_handle *h,
					   TALLOC_CTX *mem_ctx,
					   struct policy_handle *_domain_handle /* [in] [ref] */,
					   uint32_t *_unknown /* [out] [ref] */,
					   NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_GETBOOTKEYINFORMATION_COMPAT */

struct tevent_req *dcerpc_samr_Connect3_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Connect3 *r);
NTSTATUS dcerpc_samr_Connect3_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Connect3_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Connect3 *r);
#ifdef DCERPC_CALL_SAMR_CONNECT3_COMPAT
#define dcerpc_samr_Connect3(p, m, r) dcerpc_samr_Connect3_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CONNECT3_COMPAT */
NTSTATUS dcerpc_samr_Connect3_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Connect3 *r);
struct tevent_req *dcerpc_samr_Connect3_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     const char *_system_name /* [in] [unique,charset(UTF16)] */,
					     uint32_t _unknown /* [in]  */,
					     uint32_t _access_mask /* [in]  */,
					     struct policy_handle *_connect_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_Connect3_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CONNECT3_COMPAT
NTSTATUS dcerpc_samr_Connect3(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      const char *_system_name /* [in] [unique,charset(UTF16)] */,
			      uint32_t _unknown /* [in]  */,
			      uint32_t _access_mask /* [in]  */,
			      struct policy_handle *_connect_handle /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CONNECT3_COMPAT */

struct tevent_req *dcerpc_samr_Connect4_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Connect4 *r);
NTSTATUS dcerpc_samr_Connect4_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Connect4_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Connect4 *r);
#ifdef DCERPC_CALL_SAMR_CONNECT4_COMPAT
#define dcerpc_samr_Connect4(p, m, r) dcerpc_samr_Connect4_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CONNECT4_COMPAT */
NTSTATUS dcerpc_samr_Connect4_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Connect4 *r);
struct tevent_req *dcerpc_samr_Connect4_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     const char *_system_name /* [in] [unique,charset(UTF16)] */,
					     enum samr_ConnectVersion _client_version /* [in]  */,
					     uint32_t _access_mask /* [in]  */,
					     struct policy_handle *_connect_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_Connect4_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CONNECT4_COMPAT
NTSTATUS dcerpc_samr_Connect4(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      const char *_system_name /* [in] [unique,charset(UTF16)] */,
			      enum samr_ConnectVersion _client_version /* [in]  */,
			      uint32_t _access_mask /* [in]  */,
			      struct policy_handle *_connect_handle /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CONNECT4_COMPAT */

struct tevent_req *dcerpc_samr_ChangePasswordUser3_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_ChangePasswordUser3 *r);
NTSTATUS dcerpc_samr_ChangePasswordUser3_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_ChangePasswordUser3_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser3 *r);
#ifdef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER3_COMPAT
#define dcerpc_samr_ChangePasswordUser3(p, m, r) dcerpc_samr_ChangePasswordUser3_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER3_COMPAT */
NTSTATUS dcerpc_samr_ChangePasswordUser3_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_ChangePasswordUser3 *r);
struct tevent_req *dcerpc_samr_ChangePasswordUser3_send(TALLOC_CTX *mem_ctx,
							struct tevent_context *ev,
							struct dcerpc_binding_handle *h,
							struct lsa_String *_server /* [in] [unique] */,
							struct lsa_String *_account /* [in] [ref] */,
							struct samr_CryptPassword *_nt_password /* [in] [unique] */,
							struct samr_Password *_nt_verifier /* [in] [unique] */,
							uint8_t _lm_change /* [in]  */,
							struct samr_CryptPassword *_lm_password /* [in] [unique] */,
							struct samr_Password *_lm_verifier /* [in] [unique] */,
							struct samr_CryptPassword *_password3 /* [in] [unique] */,
							struct samr_DomInfo1 **_dominfo /* [out] [ref] */,
							struct userPwdChangeFailureInformation **_reject /* [out] [ref] */);
NTSTATUS dcerpc_samr_ChangePasswordUser3_recv(struct tevent_req *req,
					      TALLOC_CTX *mem_ctx,
					      NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CHANGEPASSWORDUSER3_COMPAT
NTSTATUS dcerpc_samr_ChangePasswordUser3(struct dcerpc_binding_handle *h,
					 TALLOC_CTX *mem_ctx,
					 struct lsa_String *_server /* [in] [unique] */,
					 struct lsa_String *_account /* [in] [ref] */,
					 struct samr_CryptPassword *_nt_password /* [in] [unique] */,
					 struct samr_Password *_nt_verifier /* [in] [unique] */,
					 uint8_t _lm_change /* [in]  */,
					 struct samr_CryptPassword *_lm_password /* [in] [unique] */,
					 struct samr_Password *_lm_verifier /* [in] [unique] */,
					 struct samr_CryptPassword *_password3 /* [in] [unique] */,
					 struct samr_DomInfo1 **_dominfo /* [out] [ref] */,
					 struct userPwdChangeFailureInformation **_reject /* [out] [ref] */,
					 NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CHANGEPASSWORDUSER3_COMPAT */

struct tevent_req *dcerpc_samr_Connect5_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_Connect5 *r);
NTSTATUS dcerpc_samr_Connect5_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_Connect5_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_Connect5 *r);
#ifdef DCERPC_CALL_SAMR_CONNECT5_COMPAT
#define dcerpc_samr_Connect5(p, m, r) dcerpc_samr_Connect5_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_CONNECT5_COMPAT */
NTSTATUS dcerpc_samr_Connect5_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_Connect5 *r);
struct tevent_req *dcerpc_samr_Connect5_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     const char *_system_name /* [in] [unique,charset(UTF16)] */,
					     uint32_t _access_mask /* [in]  */,
					     uint32_t _level_in /* [in]  */,
					     union samr_ConnectInfo *_info_in /* [in] [ref,switch_is(level_in)] */,
					     uint32_t *_level_out /* [out] [ref] */,
					     union samr_ConnectInfo *_info_out /* [out] [ref,switch_is(*level_out)] */,
					     struct policy_handle *_connect_handle /* [out] [ref] */);
NTSTATUS dcerpc_samr_Connect5_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_CONNECT5_COMPAT
NTSTATUS dcerpc_samr_Connect5(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      const char *_system_name /* [in] [unique,charset(UTF16)] */,
			      uint32_t _access_mask /* [in]  */,
			      uint32_t _level_in /* [in]  */,
			      union samr_ConnectInfo *_info_in /* [in] [ref,switch_is(level_in)] */,
			      uint32_t *_level_out /* [out] [ref] */,
			      union samr_ConnectInfo *_info_out /* [out] [ref,switch_is(*level_out)] */,
			      struct policy_handle *_connect_handle /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_CONNECT5_COMPAT */

struct tevent_req *dcerpc_samr_RidToSid_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_RidToSid *r);
NTSTATUS dcerpc_samr_RidToSid_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_RidToSid_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_RidToSid *r);
#ifdef DCERPC_CALL_SAMR_RIDTOSID_COMPAT
#define dcerpc_samr_RidToSid(p, m, r) dcerpc_samr_RidToSid_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_RIDTOSID_COMPAT */
NTSTATUS dcerpc_samr_RidToSid_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_RidToSid *r);
struct tevent_req *dcerpc_samr_RidToSid_send(TALLOC_CTX *mem_ctx,
					     struct tevent_context *ev,
					     struct dcerpc_binding_handle *h,
					     struct policy_handle *_domain_handle /* [in] [ref] */,
					     uint32_t _rid /* [in]  */,
					     struct dom_sid2 **_sid /* [out] [ref] */);
NTSTATUS dcerpc_samr_RidToSid_recv(struct tevent_req *req,
				   TALLOC_CTX *mem_ctx,
				   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_RIDTOSID_COMPAT
NTSTATUS dcerpc_samr_RidToSid(struct dcerpc_binding_handle *h,
			      TALLOC_CTX *mem_ctx,
			      struct policy_handle *_domain_handle /* [in] [ref] */,
			      uint32_t _rid /* [in]  */,
			      struct dom_sid2 **_sid /* [out] [ref] */,
			      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_RIDTOSID_COMPAT */

struct tevent_req *dcerpc_samr_SetDsrmPassword_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_SetDsrmPassword *r);
NTSTATUS dcerpc_samr_SetDsrmPassword_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_SetDsrmPassword_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_SetDsrmPassword *r);
#ifdef DCERPC_CALL_SAMR_SETDSRMPASSWORD_COMPAT
#define dcerpc_samr_SetDsrmPassword(p, m, r) dcerpc_samr_SetDsrmPassword_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_SETDSRMPASSWORD_COMPAT */
NTSTATUS dcerpc_samr_SetDsrmPassword_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_SetDsrmPassword *r);
struct tevent_req *dcerpc_samr_SetDsrmPassword_send(TALLOC_CTX *mem_ctx,
						    struct tevent_context *ev,
						    struct dcerpc_binding_handle *h,
						    struct lsa_String *_name /* [in] [unique] */,
						    uint32_t _unknown /* [in]  */,
						    struct samr_Password *_hash /* [in] [unique] */);
NTSTATUS dcerpc_samr_SetDsrmPassword_recv(struct tevent_req *req,
					  TALLOC_CTX *mem_ctx,
					  NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_SETDSRMPASSWORD_COMPAT
NTSTATUS dcerpc_samr_SetDsrmPassword(struct dcerpc_binding_handle *h,
				     TALLOC_CTX *mem_ctx,
				     struct lsa_String *_name /* [in] [unique] */,
				     uint32_t _unknown /* [in]  */,
				     struct samr_Password *_hash /* [in] [unique] */,
				     NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_SETDSRMPASSWORD_COMPAT */

struct tevent_req *dcerpc_samr_ValidatePassword_r_send(TALLOC_CTX *mem_ctx,
	struct tevent_context *ev,
	struct dcerpc_binding_handle *h,
	struct samr_ValidatePassword *r);
NTSTATUS dcerpc_samr_ValidatePassword_r_recv(struct tevent_req *req, TALLOC_CTX *mem_ctx);
NTSTATUS dcerpc_samr_ValidatePassword_r(struct dcerpc_binding_handle *h, TALLOC_CTX *mem_ctx, struct samr_ValidatePassword *r);
#ifdef DCERPC_CALL_SAMR_VALIDATEPASSWORD_COMPAT
#define dcerpc_samr_ValidatePassword(p, m, r) dcerpc_samr_ValidatePassword_compat(p, m, r)
#endif /* DCERPC_CALL_SAMR_VALIDATEPASSWORD_COMPAT */
NTSTATUS dcerpc_samr_ValidatePassword_compat(struct dcerpc_pipe *p, TALLOC_CTX *mem_ctx, struct samr_ValidatePassword *r);
struct tevent_req *dcerpc_samr_ValidatePassword_send(TALLOC_CTX *mem_ctx,
						     struct tevent_context *ev,
						     struct dcerpc_binding_handle *h,
						     enum samr_ValidatePasswordLevel _level /* [in]  */,
						     union samr_ValidatePasswordReq *_req /* [in] [ref,switch_is(level)] */,
						     union samr_ValidatePasswordRep **_rep /* [out] [ref,switch_is(level)] */);
NTSTATUS dcerpc_samr_ValidatePassword_recv(struct tevent_req *req,
					   TALLOC_CTX *mem_ctx,
					   NTSTATUS *result);
#ifndef DCERPC_CALL_SAMR_VALIDATEPASSWORD_COMPAT
NTSTATUS dcerpc_samr_ValidatePassword(struct dcerpc_binding_handle *h,
				      TALLOC_CTX *mem_ctx,
				      enum samr_ValidatePasswordLevel _level /* [in]  */,
				      union samr_ValidatePasswordReq *_req /* [in] [ref,switch_is(level)] */,
				      union samr_ValidatePasswordRep **_rep /* [out] [ref,switch_is(level)] */,
				      NTSTATUS *result);
#endif /* DCERPC_CALL_SAMR_VALIDATEPASSWORD_COMPAT */

#endif /* _HEADER_RPC_samr */
